commit ff5b3f85397394c86cefd204b728d932cb356104
Author: freddy77 <freddy77>
Date:   Sat Jan 9 09:17:46 2010 +0000

    Fix possible wrong error report if malloc does not set errno

diff --git a/ChangeLog b/ChangeLog
index 70f4381..e460567 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sat Jan  9 10:17:41 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/replacements/vasprintf.c:
+	- Fix possible wrong error report if malloc does not set errno
+
 Fri Jan  8 17:38:50 EST 2010	JK Lowden <jklowden@freetds.org>
 	* include/replacements.h src/apps/bsqldb.c src/tds/mem.c
 	- tsql works in win32, optarg is not const
@@ -2047,4 +2051,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2921 2010/01/08 22:41:34 jklowden Exp $
+$Id: ChangeLog,v 1.2922 2010/01/09 09:17:46 freddy77 Exp $
diff --git a/src/replacements/vasprintf.c b/src/replacements/vasprintf.c
index 9183903..7312519 100644
--- a/src/replacements/vasprintf.c
+++ b/src/replacements/vasprintf.c
@@ -15,6 +15,10 @@
 #include <stdlib.h>
 #endif /* HAVE_STDLIB_H */
 
+#if HAVE_ERRNO_H
+#include <errno.h>
+#endif /* HAVE_ERRNO_H */
+
 #if HAVE_STRING_H
 #include <string.h>
 #endif /* HAVE_STRING_H */
@@ -30,7 +34,7 @@
 #include "tds_sysdep_private.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: vasprintf.c,v 1.20 2009/01/21 08:34:01 freddy77 Exp $");
+TDS_RCSID(var, "$Id: vasprintf.c,v 1.21 2010/01/09 09:17:47 freddy77 Exp $");
 
 #if defined(HAVE__VSNPRINTF) && !defined(HAVE_VSNPRINTF)
 #undef HAVE_VSNPRINTF
@@ -57,6 +61,7 @@ vasprintf(char **ret, const char *fmt, va_list ap)
 	buflen = chunks * CHUNKSIZE;
 	for (;;) {
 		if ((buf = malloc(buflen)) == NULL) {
+			errno = ENOMEM;
 			*ret = NULL;
 			return -1;
 		}
@@ -109,8 +114,10 @@ vasprintf(char **ret, const char *fmt, va_list ap)
 
 	if (len < 0)
 		return len;
-	if ((buf = malloc(len + 1)) == NULL)
+	if ((buf = malloc(len + 1)) == NULL) {
+		errno = ENOMEM;
 		return -1;
+	}
 	if (vsprintf(buf, fmt, ap) != len)
 		return -1;
 	*ret = buf;

